# frozen_string_literal: true

module Zn
  module Associators
    # BelongsTo associator helps define belongs_to relations between objects
    class BelongsTo
      attr_reader :datasets, :dataset_name, :foreign_key, :primary_key, :dataset, :repo

      def initialize(datasets, params)
        raise ArgumentError, 'Datasets is nil' if datasets.nil?

        @datasets = datasets
        @dataset_name = params.fetch('dataset')
        @foreign_key = params.fetch('foreign_key')
        @primary_key = params.fetch('primary_key')
      end

      def associate(object)
        @dataset ||= datasets.fetch(dataset_name)
        dataset.search(key: primary_key, value: object.fetch(foreign_key), exact: true).to_a.first
      end
    end
  end
end
