# frozen_string_literal: true

module Zn
  module Associators
    # HasMany associator helps define has_many relations between objects
    class HasMany
      attr_reader :datasets, :dataset_name, :foreign_key, :primary_key, :dataset, :repo

      def initialize(datasets, params)
        raise ArgumentError, 'Datasets is nil' if datasets.nil?

        @datasets = datasets
        @dataset_name = params.fetch('dataset')
        @foreign_key = params.fetch('foreign_key')
        @primary_key = params.fetch('primary_key')
      end

      def associate(object)
        @dataset ||= datasets.fetch(dataset_name)

        dataset.search(key: foreign_key, value: object.fetch(primary_key), exact: true).to_a
      end
    end
  end
end
